//
//  OSBase.h
//  AppleUSBAudio
//
//  Created by Иван Мельников on 09.03.16.
//
//

#ifndef _OS_OSBASE_H
#define _OS_OSBASE_H

#include <sys/cdefs.h>

#include <libkern/OSTypes.h>

#include <stdint.h>

__BEGIN_DECLS


OS_INLINE
uint64_t
__OSAbsoluteTime(
                 AbsoluteTime	abstime)
{
    return (*(uint64_t *)&abstime);
}

OS_INLINE
uint64_t *
__OSAbsoluteTimePtr(
                    AbsoluteTime	*abstime)
{
    return ((uint64_t *)abstime);
}

#define AbsoluteTime_to_scalar(x)	(*(uint64_t *)(x))

/* t1 < = > t2 */
#define CMP_ABSOLUTETIME(t1, t2)				\
(AbsoluteTime_to_scalar(t1) >				\
AbsoluteTime_to_scalar(t2)? (int)+1 :	\
(AbsoluteTime_to_scalar(t1) <				\
AbsoluteTime_to_scalar(t2)? (int)-1 : 0))

/* t1 += t2 */
#define ADD_ABSOLUTETIME(t1, t2)				\
(AbsoluteTime_to_scalar(t1) +=				\
AbsoluteTime_to_scalar(t2))

/* t1 -= t2 */
#define SUB_ABSOLUTETIME(t1, t2)				\
(AbsoluteTime_to_scalar(t1) -=				\
AbsoluteTime_to_scalar(t2))

#define ADD_ABSOLUTETIME_TICKS(t1, ticks)		\
(AbsoluteTime_to_scalar(t1) +=				\
(int32_t)(ticks))


__END_DECLS

#endif /* _OS_OSBASE_H */
